Public Class Dashboard

    Private _DS As DataSet
    Private _DSPath As String
    Private _IsDirty As Boolean = False

    Friend Sub SetupForm()
        Me.Text = "App Dashboard - Untitled"
        SetupDataset()
        SetupButton(Button1)
        SetupButton(Button2)
        SetupButton(Button3)
        SetupButton(Button4)
        SetupButton(Button5)
        SetupButton(Button6)
        SetupButton(Button7)
        SetupButton(Button8)
        SetupButton(Button9)
        SetupButton(Button10)
        SetupButton(Button11)
        SetupButton(Button12)
        SetupButton(Button13)
        SetupButton(Button14)
        SetupButton(Button15)
        SetupButton(Button16)
        SetupButton(Button17)
        SetupButton(Button18)
        SetupButton(Button19)
        SetupButton(Button20)
    End Sub

    Friend Sub OpenFile(ByVal Path As String)
        Dim bSuccess As Boolean = False

        If IO.File.Exists(Path) Then
            Try
                _DS.ReadXml(Path)
                If Not _DS Is Nothing AndAlso _DS.Tables.Contains("App") Then
                    bSuccess = True
                    Me.Text = "App Dashboard - " & IO.Path.GetFileName(Path)
                    _DSPath = Path
                    My.Settings.LastADSHFilePath = Path
                    _IsDirty = False

                    Dim sButton, sDisplayName, sPath As String
                    Dim b As Button
                    Dim c() As Control

                    For Each oRow As DataRow In _DS.Tables("App").Rows
                        sButton = oRow("Button")
                        sDisplayName = oRow("DisplayName")
                        sPath = oRow("Path")

                        If Not sButton Is Nothing AndAlso Me.Controls.Find(sButton, True) IsNot Nothing AndAlso Me.Controls.Find(sButton, True).Length > 0 Then
                            If Not sDisplayName Is Nothing AndAlso sDisplayName.Trim.Length > 0 Then
                                If sPath Is Nothing Then
                                    sPath = ""
                                End If


                                c = Me.Controls.Find(sButton, True)
                                If c.Length > 0 AndAlso TypeOf c(0) Is Button Then
                                    b = CType(c(0), Button)
                                    b.Text = sDisplayName
                                    b.Tag = sPath
                                End If



                            End If
                        End If


                    Next
                End If
            Catch ex As Exception
            End Try
        End If
    End Sub

    Private Sub Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles Button1.Click, Button2.Click, Button3.Click, Button4.Click, Button5.Click, _
        Button6.Click, Button7.Click, Button8.Click, Button9.Click, Button10.Click, _
        Button11.Click, Button12.Click, Button13.Click, Button14.Click, Button15.Click, Button16.Click, Button20.Click, Button19.Click, Button18.Click, Button17.Click

        Dim b As Button = CType(sender, Button)
        If b.Tag.ToString = "" Then
            MessageBox.Show("Not defined.  You can configure this button " & vbCrLf & "by right clicking on it and choosing Configure Button.")
        ElseIf System.IO.File.Exists(b.Tag.ToString) OrElse IsUrl(b.Tag.ToString) Then
            System.Diagnostics.Process.Start(b.Tag.ToString)
        Else
            MessageBox.Show("Invalid path.  You can configure this button " & vbCrLf & "by right clicking on it and choosing Configure Button.")
        End If
    End Sub

    Private Function IsUrl(ByVal Input As String) As Boolean
        ' for now, if it starts with http://, https://, or ftp:// consider it a URL and let the browser handle errors
        ' maybe in the future, add regex validation, etc
        If Input Is Nothing Then
            Return False
        Else
            Return Input.ToLower.StartsWith("http://") OrElse Input.ToLower.StartsWith("https://") OrElse Input.ToLower.StartsWith("ftp://")
        End If
    End Function

    Private Sub Dashboard_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Not PromptSaveIfNecessary() Then
            e.Cancel = True
        End If
    End Sub

    Private Sub SetupButton(ByRef b As Button, ByVal t As String, ByVal p As String)
        b.Text = t
        b.Tag = p
        b.ContextMenuStrip.Tag = b
    End Sub

    Private Sub SetupButton(ByRef b As Button)
        b.Text = "Not defined.  Right click to configure."
        b.Tag = ""
        b.ContextMenuStrip.Tag = b
    End Sub

    Private Sub EditToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditToolStripMenuItem.Click
        Dim oID As New ItemDetail(ContextMenuStrip1.SourceControl.Name, ContextMenuStrip1.SourceControl.Text, ContextMenuStrip1.SourceControl.Tag.ToString)
        Dim oRes As DialogResult = oID.ShowDialog(Me)

        If oRes = Windows.Forms.DialogResult.OK OrElse oRes = Windows.Forms.DialogResult.Yes Then
            If oID.DisplayName Is Nothing OrElse oID.DisplayName.Trim.Length <= 0 OrElse oID.Path Is Nothing OrElse oID.Path.Trim.Length <= 0 Then
                ' clear the button
                ClearButton(CType(ContextMenuStrip1.SourceControl, Button))
            Else
                ContextMenuStrip1.SourceControl.Text = oID.DisplayName
                ContextMenuStrip1.SourceControl.Tag = oID.Path

                Dim bAddNew As Boolean = True
                For Each oRow As DataRow In _DS.Tables("App").Rows
                    If oRow("Button") = oID.ButtonID Then
                        oRow("DisplayName") = oID.DisplayName
                        oRow("Path") = oID.Path
                        bAddNew = False
                        Exit For
                    End If
                Next

                If bAddNew Then
                    Dim oRow As DataRow = _DS.Tables("App").NewRow

                    oRow("Button") = oID.ButtonID
                    oRow("DisplayName") = oID.DisplayName
                    oRow("Path") = oID.Path

                    _DS.Tables("App").Rows.Add(oRow)
                End If

                _IsDirty = True
            End If
        End If
    End Sub

    Private Sub ClearButton(ByRef b As Button)
        If b.Tag <> "" Then 'button is not already cleared
            Dim oRes As DialogResult = MessageBox.Show("Are you sure you want to clear this button?", "Are you sure?", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)
            If oRes = Windows.Forms.DialogResult.Yes Then
                SetupButton(b)
                _IsDirty = True
            End If
        End If
    End Sub

    Private Sub ClearButtonToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearButtonToolStripMenuItem.Click
        ClearButton(CType(ContextMenuStrip1.SourceControl, Button))
    End Sub

    Private Sub SetupDataset()
        _DSPath = ""
        _DS = New DataSet("Apps")
        _DS.Tables.Add("App")
        _DS.Tables("App").Columns.Add("Button", GetType(String))
        _DS.Tables("App").Columns.Add("DisplayName", GetType(String))
        _DS.Tables("App").Columns.Add("Path", GetType(String))
    End Sub

    Private Sub SaveFile(Optional ByVal ForceSaveAs As Boolean = False)
        Dim bSaveIt As Boolean = False

        If ForceSaveAs OrElse _DSPath Is Nothing OrElse _DSPath.Trim.Length <= 0 Then
            SaveFileDialog1.Filter = "App Dashboard File (*.ADSH)|*.adsh|All files (*.*)|*.*"
            Dim oRes2 As DialogResult = SaveFileDialog1.ShowDialog(Me)
            If oRes2 = Windows.Forms.DialogResult.OK OrElse oRes2 = Windows.Forms.DialogResult.Yes Then
                _DSPath = SaveFileDialog1.FileName
                bSaveIt = True
            End If
        Else
            bSaveIt = True
        End If

        If bSaveIt Then
            _DS.WriteXml(_DSPath)
        End If

        _IsDirty = False
    End Sub

    Private Function PromptSaveIfNecessary() As Boolean
        Dim bRet As Boolean = True

        If _IsDirty Then
            Dim oRes As DialogResult = MessageBox.Show("You have unsaved changes.  Do you want to save before continuing?", "App Dashboard", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1)
            If oRes = Windows.Forms.DialogResult.Yes Then
                SaveFile()
                bRet = True
            ElseIf oRes = Windows.Forms.DialogResult.No Then
                bRet = True
            Else   'oRes = Windows.Forms.DialogResult.Cancel Then
                bRet = False
            End If
        End If

        Return bRet
    End Function

    Private Sub SaveToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripButton.Click
        SaveFile()
    End Sub

    Private Sub NewToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewToolStripButton.Click
        If PromptSaveIfNecessary() Then
            SetupForm()
        End If
    End Sub

    Private Sub OpenToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripButton.Click
        If PromptSaveIfNecessary() Then
            OpenFileDialog1.Filter = "App Dashboard File (*.ADSH)|*.adsh|All files (*.*)|*.*"
            Dim oRes As DialogResult = OpenFileDialog1.ShowDialog(Me)
            If oRes = Windows.Forms.DialogResult.OK OrElse oRes = Windows.Forms.DialogResult.Yes Then
                OpenFile(OpenFileDialog1.FileName)
            End If
        End If
    End Sub

    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAsToolStripMenuItem.Click
        SaveFile(True)
    End Sub

    Private Sub HelpToolStripButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HelpToolStripButton.Click
        Dim sPath As String = IO.Path.Combine(IO.Path.GetDirectoryName(Application.ExecutablePath), "Help.html")

        If System.IO.File.Exists(sPath) Then
            System.Diagnostics.Process.Start(sPath)
        Else
            MessageBox.Show("Help file not found at " & vbCrLf & sPath)
        End If
    End Sub

    Private Sub ContextMenuStrip1_Opening(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles ContextMenuStrip1.Opening
        If ContextMenuStrip1.SourceControl.Tag = "" Then
            ContextMenuStrip1.Items("ClearButtonToolStripMenuItem").Enabled = False
        Else
            ContextMenuStrip1.Items("ClearButtonToolStripMenuItem").Enabled = True
        End If
    End Sub
End Class