Imports Microsoft.Win32

Public Class Program

    <STAThread()> _
    Public Shared Sub Main()
        Dim fDashboard As New Dashboard
        fDashboard.SetupForm()

        Dim sFirstArg As String = ""
        If My.Application.CommandLineArgs.Count > 0 AndAlso My.Application.CommandLineArgs(0) IsNot Nothing AndAlso My.Application.CommandLineArgs(0).Trim.Length > 0 Then
            sFirstArg = My.Application.CommandLineArgs(0)
        End If

        Dim bRunApp As Boolean = True

        If sFirstArg.ToLower = "-?" OrElse sFirstArg.ToLower = "/?" Then
            Dim sUsage As String = "App Dashboard can be started with zero or one command line args, defined as follows:" & vbCrLf _
                & "    -i to associate .adsh files with App Dashboard" & vbCrLf _
                & "    -u to disassociate .adsh files from App Dashboard" & vbCrLf _
                & "    -? to show this usage dialog" & vbCrLf _
                & "    a path to a dashboard group file (*.adsh)" & vbCrLf
            MessageBox.Show(sUsage, "Usage", MessageBoxButtons.OK, MessageBoxIcon.Information)
            bRunApp = False
        ElseIf sFirstArg.ToLower = "-i" OrElse sFirstArg.ToLower = "/i" Then
            RegisterApp()
            MessageBox.Show("App Dashboard has been registered.")
            bRunApp = False
        ElseIf sFirstArg.ToLower = "-u" OrElse sFirstArg.ToLower = "/u" Then
            UnregisterApp()
            MessageBox.Show("App Dashboard has been unregistered.")
            bRunApp = False
        ElseIf IO.File.Exists(sFirstArg) Then
            fDashboard.OpenFile(sFirstArg)
        ElseIf My.Settings.LastADSHFilePath IsNot Nothing AndAlso My.Settings.LastADSHFilePath.Trim.Length > 0 AndAlso IO.File.Exists(My.Settings.LastADSHFilePath) Then
            fDashboard.OpenFile(My.Settings.LastADSHFilePath)
        End If

        If bRunApp Then
            fDashboard.StartPosition = My.Settings.MainFormStartPosition
            fDashboard.WindowState = My.Settings.MainFormWindowState

            Application.EnableVisualStyles()
            Application.Run(fDashboard)

            My.Settings.MainFormStartPosition = fDashboard.StartPosition
            My.Settings.MainFormWindowState = fDashboard.WindowState

            My.Settings.Save()
        End If

    End Sub


    Private Shared Sub RegisterApp()
        Dim key As RegistryKey

        key = Registry.ClassesRoot.CreateSubKey(".adsh")
        key.SetValue(Nothing, "adshfile")

        key = Registry.ClassesRoot.CreateSubKey("adshfile\shell\open\command")
        key.SetValue(Nothing, Application.ExecutablePath + " ""%L""")

        Dim sIcoPath As String = IO.Path.GetDirectoryName(Application.ExecutablePath) & "\app.ico"
        key = Registry.ClassesRoot.CreateSubKey("adshfile\DefaultIcon")
        key.SetValue(Nothing, sIcoPath)
    End Sub

    Private Shared Sub UnregisterApp()
        Registry.ClassesRoot.DeleteSubKey("adshfile\DefaultIcon", False)
        Registry.ClassesRoot.DeleteSubKey("adshfile\shell\open\command", False)
        Registry.ClassesRoot.DeleteSubKey(".adsh", False)
    End Sub

End Class
